use crate::compositions;
use crate::repositories;
use beteran_protobuf_rust as bpr;

impl From<&repositories::member_bank_withdraw::models::MemberBankWithdraw>
  for bpr::models::member_bank_withdraw::MemberBankWithdraw
{
  fn from(d: &repositories::member_bank_withdraw::models::MemberBankWithdraw) -> Self {
    bpr::models::member_bank_withdraw::MemberBankWithdraw {
      id: d.id.to_string(),
      member_id: d.member_id.to_string(),
      bank_name: d.bank_name.clone(),
      account_number: d.account_number.clone(),
      password: d.password.clone(),
      name: d.name.clone(),
      amount: d.amount as u32,
      memo: d.memo.clone(),
      state: d.state as i32,
      state_changed_at: d.state_changed_at as u64,
      created_at: d.created_at as u64,
      updated_at: d.updated_at as u64,
    }
  }
}

impl From<&compositions::member_bank_withdraw::models::MemberBankWithdrawModel>
  for bpr::models::member_bank_withdraw::MemberBankWithdrawModel
{
  fn from(d: &compositions::member_bank_withdraw::models::MemberBankWithdrawModel) -> Self {
    bpr::models::member_bank_withdraw::MemberBankWithdrawModel {
      id: d.id.to_string(),
      member: Some(bpr::models::member::Member::from(&d.member)),
      bank_name: d.bank_name.clone(),
      account_number: d.account_number.clone(),
      password: d.password.clone(),
      name: d.name.clone(),
      amount: d.amount as u32,
      memo: d.memo.clone(),
      state: d.state as i32,
      state_changed_at: d.state_changed_at as u64,
      created_at: d.created_at as u64,
      updated_at: d.updated_at as u64,
    }
  }
}

impl From<i32> for repositories::member_bank_withdraw::schema::MemberBankWithdrawState {
  fn from(s: i32) -> Self {
    match s {
      s if s
        == repositories::member_bank_withdraw::schema::MemberBankWithdrawState::Complete as i32 =>
      {
        repositories::member_bank_withdraw::schema::MemberBankWithdrawState::Complete
      }
      _ => repositories::member_bank_withdraw::schema::MemberBankWithdrawState::Application,
    }
  }
}
