use crate::repositories;
use beteran_protobuf_rust as bpr;

impl From<i32> for repositories::member_settlement_setting::schema::ManualPaymentType {
  fn from(s: i32) -> Self {
    match s {
      s if s
        == repositories::member_settlement_setting::schema::ManualPaymentType::AllChildPartner
          as i32 =>
      {
        repositories::member_settlement_setting::schema::ManualPaymentType::AllChildPartner
      }
      s if s
        == repositories::member_settlement_setting::schema::ManualPaymentType::OnlyDirectPartner
          as i32 =>
      {
        repositories::member_settlement_setting::schema::ManualPaymentType::OnlyDirectPartner
      }
      _ => repositories::member_settlement_setting::schema::ManualPaymentType::Disable,
    }
  }
}

impl From<i32> for repositories::member_settlement_setting::schema::SettlementType {
  fn from(s: i32) -> Self {
    match s {
      s if s == repositories::member_settlement_setting::schema::SettlementType::Loosing as i32 => {
        repositories::member_settlement_setting::schema::SettlementType::Loosing
      }
      _ => repositories::member_settlement_setting::schema::SettlementType::Rolling,
    }
  }
}

impl From<&repositories::member_settlement_setting::models::MemberSettlementSetting>
  for bpr::models::member_settlement_setting::MemberSettlementSetting
{
  fn from(d: &repositories::member_settlement_setting::models::MemberSettlementSetting) -> Self {
    bpr::models::member_settlement_setting::MemberSettlementSetting {
      id: d.id.to_string(),
      member_id: d.member_id.to_string(),
      can_exchange: d.can_exchange,
      can_first_charge_comp: d.can_first_charge_comp,
      can_per_charge_comp: d.can_per_charge_comp,
      settlement_type: d.settlement_type as i32,
      manual_payment_type_for_partner: d.manual_payment_type_for_partner as i32,
      rate_casino: d.rate_casino,
      rate_casino_loosing: d.rate_casino_loosing,
      rate_casino_bacara: d.rate_casino_bacara,
      rate_casino_roulette: d.rate_casino_roulette,
      rate_casino_dragon_tiger: d.rate_casino_dragon_tiger,
      rate_slot: d.rate_slot,
      rate_slot_loosing: d.rate_slot_loosing,
      rate_powerball_single: d.rate_powerball_single,
      rate_powerball_combo: d.rate_powerball_combo,
      rate_powerladder_single: d.rate_powerladder_single,
      rate_powerladder_combo: d.rate_powerladder_combo,
      rate_eos_single: d.rate_eos_single,
      rate_eos_combo: d.rate_eos_combo,
      rate_bogglepowerball_single: d.rate_bogglepowerball_single,
      rate_bogglepowerball_combo: d.rate_bogglepowerball_combo,
      created_at: d.created_at as u64,
      updated_at: d.updated_at as u64,
    }
  }
}
